//
//  ChatChatMainDaegiChatViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 05. 03.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatMainDaegiChatViewController.h"
#import "ClubChatData.h"

@implementation ClubChatMainDaegiChatViewController

- (void)viewDidLoad {
    [super viewDidLoad];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMsg:) name:@"receiveMsg" object:nil];
	
	[_textView setFont:[UIFont systemFontOfSize:11]];
}

- (BOOL)textViewShouldBeginEditing:(UITextView *)textView{
	
	[_textField resignFirstResponder];
	
	[_textView	setFrame:CGRectMake(0.0f,0.0f,320.0f,395.0f)];
	[_textField	setFrame:CGRectMake(3.0f,398.0f,315.0f,31.0f)];
	
	
	NSLog(@"textView's length is %d",[_textView.text length]);
	
	if([_textView.text length]!=0){
		[_textView scrollRangeToVisible:NSMakeRange([_textView.text length]-7,7)];
	}
	
	return YES;
}
- (void)textFieldDidBeginEditing:(UITextField *)textField{
	NSLog(@"textFieldDidBeginEditing");
	[_textView	setFrame:CGRectMake(0.0f,0.0f,320.0f,180.0f)];
	[_textField	setFrame:CGRectMake(3.0f,183.0f,315.0f,31.0f)];
	
	if([_textView.text length]!=0){
		[_textView scrollRangeToVisible:NSMakeRange([_textView.text length]-7,7)];
	}
}

//텍스트필드에서 입력된내용에 대한처리..
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
	//서버로전송처리..
	ClubChatData *data=[[ClubChatData alloc] initWithHeader:@"/대기" andWithMsg:textField.text];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
	
	//내용을 지운다..
	[textField setText:@""];
	return YES;
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
	
	[_textField becomeFirstResponder];
}
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
	[_textField resignFirstResponder];
}

-(void)receiveMsg:(NSNotification *)notification{
	ClubChatData *data=(ClubChatData *)notification.object;
	if([data.header isEqualToString:@"/대기"]){
		
		NSString *who=[data.array objectAtIndex:0];
		NSString *msg=[data.array objectAtIndex:1];
		NSString *viewMsg=[NSString stringWithFormat:@"%@님의 말>> %@",who,msg];
		
		_textView.text=[_textView.text stringByAppendingString:viewMsg];
		_textView.text=[_textView.text stringByAppendingString:@"\n"];
		
		[_textView scrollRangeToVisible:NSMakeRange([_textView.text length]-7,7)];
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self name:@"receiveMsg" object:nil];
	
	[_textView	release];
	[_textField release];
	
    [super dealloc];
}

@end
