//
//  ClubChatMainViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 04. 19.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatMainViewController.h"
#import "ClubChatMainChatRoomListViewController.h"
#import "ClubChatMainDaegiChatViewController.h"
#import "ClubChatMainEtcViewController.h"
#import "ClubChatData.h"

@interface ClubChatMainViewController(PrivateMethods)
//메세지전송..
-(void)sendMsgWithHeader:(NSString *)header andWithMsg:(NSString *)msg;
@end

@implementation ClubChatMainViewController
/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/
/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	NSLog(@"viewDidLoad");
	
	[segmentedControl addTarget:self
						 action:@selector(action:)
			   forControlEvents:UIControlEventValueChanged];
}
-(void)action:(UISegmentedControl *)event{
	
	if(event.selectedSegmentIndex==0){
		[self sendMsgWithHeader:@"/목록갱신" andWithMsg:@""];
		[contentView addSubview:mainChatRoomListViewController.view];
		
		[mainChatRoomListViewController viewWillAppear:NO];
		[mainDaegiChatViewController viewDidDisappear:NO];
		[mainEtcViewController setIsModalProcess:YES];
		[mainEtcViewController viewDidDisappear:NO];
	
	}else if(event.selectedSegmentIndex==1){
		[contentView addSubview:mainDaegiChatViewController.view];
		
		//mainEtcViewController viewDidDisappear가 먼저나와서
		//혹시나 DetailViewController이 올라온상태로 된것을
		//해제시키고 다른 화면(여기선 DaegiChatViewcontroller) 을 viewWillAppear 시켜야한다.
		[mainEtcViewController setIsModalProcess:YES];
		[mainEtcViewController viewDidDisappear:NO];
		[mainChatRoomListViewController viewDidDisappear:NO];
		[mainDaegiChatViewController viewWillAppear:NO];
		
		//흠..쌓일줄알았는데...아니네~ 'ㅡ');;;
		NSLog(@"count : %d",[[self.view subviews] count]);
	}else if(event.selectedSegmentIndex==2){
		[contentView addSubview:mainEtcViewController.view];
		
		[mainChatRoomListViewController viewDidDisappear:NO];
		[mainDaegiChatViewController viewDidDisappear:NO];
		[mainEtcViewController setIsModalProcess:YES];
		[mainEtcViewController viewWillAppear:NO];
		[mainEtcViewController setSuperViewController:self];
	}
}
//메세지전송..
-(void)sendMsgWithHeader:(NSString *)header andWithMsg:(NSString *)msg{
	NSMutableArray *array=[[NSMutableArray alloc] init];
	[array addObject:msg];
	
	ClubChatData *data=[[ClubChatData alloc] initWithHeader:header andWithArray:array];
	
	[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
	
	[array release];
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
	
	NSLog(@"viewWillAppear");
	
	mainChatRoomListViewController	=[[ClubChatMainChatRoomListViewController	alloc] initWithNibName:@"ClubChatMainChatRoomListViewController"	bundle:nil];
	mainDaegiChatViewController		=[[ClubChatMainDaegiChatViewController		alloc] initWithNibName:@"ClubChatMainDaegiChatViewController"		bundle:nil];
	mainEtcViewController			=[[ClubChatMainEtcViewController			alloc] initWithNibName:@"ClubChatMainEtcViewController"				bundle:nil];
	
	[mainChatRoomListViewController viewWillAppear:animated];
	[mainDaegiChatViewController	viewWillAppear:animated];
	[mainEtcViewController			viewWillAppear:animated];
	
	[self action:segmentedControl];
}
- (void)viewDidAppear:(BOOL)animated {
	[super viewDidAppear:animated];
	
	[mainChatRoomListViewController viewDidAppear:animated];
	[mainDaegiChatViewController	viewDidAppear:animated];
	[mainEtcViewController			viewDidAppear:animated];
}
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
	
	[mainChatRoomListViewController viewWillDisappear:animated];
	[mainDaegiChatViewController	viewWillDisappear:animated];
	[mainEtcViewController			viewWillDisappear:animated];
}
- (void)viewDidDisappear:(BOOL)animated {
	[super	viewDidDisappear:animated];
	
	//대화방목록이 화면에 나오도록설정..
	//이부분을 끝으로 옮기면 에러남~ 'ㅡ')~..
	[segmentedControl setSelectedSegmentIndex:0];
	
	[mainChatRoomListViewController viewDidDisappear:animated];
	[mainDaegiChatViewController	viewDidDisappear:animated];	
	[mainEtcViewController			viewDidDisappear:animated];
	
	[mainChatRoomListViewController release];
	[mainDaegiChatViewController	release];
	[mainEtcViewController			release];
}
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[segmentedControl	release];
	[contentView		release];
    [super				dealloc];
}


@end
