//
//  ClubChatChangeNameViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 05. 26.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatChangeNameViewController.h"
#import "ClubChatData.h"
#import "ClubChatAppDelegate.h"

@implementation ClubChatChangeNameViewController

/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/

- (void)viewDidLoad {
    [super viewDidLoad];

    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMsg:) name:@"receiveMsg" object:nil];
}

/*
- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
}
*/
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
	
	[chatNameTextField resignFirstResponder];
}

/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 3;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    if(section==0){
		return 1;
	}else if(section==1){
		return 2;
	}else{
		return 1;
	}
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
    }
    
	cell.selectionStyle=UITableViewCellSelectionStyleNone;
	
    // Set up the cell...
	if(indexPath.section==0){
		
		[cell setFont:[UIFont systemFontOfSize:14]];
		cell.text=chatRoomName;
	}else if(indexPath.section==1){
		if(indexPath.row==0){
			ClubChatAppDelegate *delegate=(ClubChatAppDelegate *)[[UIApplication sharedApplication] delegate];
			
			chatNameTextField=[[UITextField alloc] initWithFrame:CGRectMake(20,9, 280, 25)];
			[chatNameTextField setBackgroundColor:[UIColor whiteColor]];
			[chatNameTextField setBorderStyle:UITextBorderStyleNone];
			[chatNameTextField setDelegate:self];
			chatNameTextField.returnKeyType=UIReturnKeyDone;
			[chatNameTextField setText:@""];
			[chatNameTextField setPlaceholder:[NSString stringWithFormat:@"현재 대화명은 \"%@\" 입니다.",delegate.chatName]];
			
			[cell addSubview:chatNameTextField];
		}else if(indexPath.row==1){
			UIButton *btn=[UIButton buttonWithType:UIButtonTypeRoundedRect];
			[btn setFrame:CGRectMake(15, 4, 290, 35)];
			[btn setTitle:@"변경" forState:UIControlStateNormal];
			[cell addSubview:btn];
			
			//처리할 이벤트등록..
			[btn addTarget:self action:@selector(touchChatNameChange:) forControlEvents:UIControlEventTouchUpInside];
		}
	}else{
		UIButton *exitButton=[UIButton buttonWithType:UIButtonTypeRoundedRect];
		[exitButton setFrame:CGRectMake(15, 4, 290, 35)];
		[exitButton setTitle:@"방나가기" forState:UIControlStateNormal];
		[cell addSubview:exitButton];
		
		//처리할 이벤트등록..
		[exitButton addTarget:self action:@selector(touchChatRoomExit:) forControlEvents:UIControlEventTouchUpInside];
	}
	
    return cell;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section{
	if(section==0){
		return @"방제";
	}if(section==1){
		return @"대화명변경";
	}else{
		return @"";
	}
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField{
	[textField resignFirstResponder];
	return YES;
}

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

//대화명변경처리..
-(void)touchChatNameChange:(id)sender{
	
	[chatNameTextField resignFirstResponder];
	
	NSString *checkGap=chatNameTextField.text;
	checkGap=[checkGap stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	
	if([checkGap isEqualToString:@""]){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
														message:@"변경할 대화명을 입력해 주십시요."
													   delegate:nil 
											  cancelButtonTitle:@"OK" 
											  otherButtonTitles: nil];
		[alert show];	
		[alert release];
		
		[chatNameTextField setText:@""];
	}else{
		ClubChatData *data=[[ClubChatData alloc] initWithHeader:@"/대화명" andWithMsg:checkGap];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
	}
}

//서버에서 받은 메세지를 처리한다./대화명변경승인|마르코|
-(void)receiveMsg:(NSNotification *)notification{
	
	ClubChatData *data=(ClubChatData *)[notification object];
	
	if([data.header isEqualToString:@"/대화명변경승인"]){
		NSLog(@"data : %@",data.msg);
		//따로 얼럿처리등은 하지않고..
		//화면에 나오는 정보등만 수정한다.
		ClubChatAppDelegate *delegate=(ClubChatAppDelegate *)[[UIApplication sharedApplication] delegate];
		
		[chatNameTextField setText:@""];
		[chatNameTextField setPlaceholder:[NSString stringWithFormat:@"현재 대화명은 \"%@\" 입니다.",delegate.chatName]];
		[chatNameTextField resignFirstResponder];
		
	}else if([data.header isEqualToString:@"/시스템"]){		
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
														message:[data.array objectAtIndex:0]
													   delegate:nil 
											  cancelButtonTitle:@"OK" 
											  otherButtonTitles: nil];
		[alert show];	
		[alert release];
		
		[chatNameTextField setText:@""];
		[chatNameTextField resignFirstResponder];
	}else if([data.header isEqualToString:@"/방제목"]){
		// /방제목|sddd
		chatRoomName=[data.array objectAtIndex:0];
	}
}

//대화방나가기
-(void)touchChatRoomExit:(id)sender{
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"ClubChat" 
													message:@"나가시겠습니까?"
												   delegate:self 
										  cancelButtonTitle:@"아니오" 
										  otherButtonTitles:@"네",nil];
	[alert show];	
	[alert release];
}
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
	//취소가 아니라면 퇴장한다.
	if(buttonIndex!=0){
		ClubChatData *data=[[ClubChatData alloc] initWithHeader:@"/퇴장" andWithMsg:@""];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
	}
}
- (void)dealloc {
	[[NSNotificationCenter defaultCenter] removeObserver:self name:@"receiveMsg" object:nil];
	
	[chatNameTextField release];
	[chatRoomName release];
    [super dealloc];
}


@end

