//
//  ClubChatChatRoomViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 05. 26.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatChatRoomViewController.h"
#import "ClubChatData.h"

@implementation ClubChatChatRoomViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	NSLog(@"ClubChatChatRoomViewcontroller.viewDidLoad");
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receiveMsg:) name:@"receiveMsg" object:nil];
	
	[_textView setFont:[UIFont systemFontOfSize:11]];
}

- (BOOL)textViewShouldBeginEditing:(UITextView *)textView{
	
	[_textField resignFirstResponder];
	
	[_textView	setFrame:CGRectMake(0.0f,0.0f,320.0f,395.0f)];
	[_textField	setFrame:CGRectMake(3.0f,398.0f,315.0f,31.0f)];
	
	if([_textView.text length]!=0){
		[_textView scrollRangeToVisible:NSMakeRange([_textView.text length]-7,7)];
	}
	
	return YES;
}
- (void)textFieldDidBeginEditing:(UITextField *)textField{
	NSLog(@"textFieldDidBeginEditing");
	[_textView	setFrame:CGRectMake(0.0f,0.0f,320.0f,180.0f)];
	[_textField	setFrame:CGRectMake(3.0f,183.0f,315.0f,31.0f)];
	
	if([_textView.text length]!=0){
		[_textView scrollRangeToVisible:NSMakeRange([_textView.text length]-7,7)];
	}
}

//텍스트필드에서 입력된내용에 대한처리..
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
	//서버로전송처리..
	///대화|/모두|하고싶은메세지|
	ClubChatData *data=[[ClubChatData alloc] initWithHeader:@"/대화|/모두" andWithMsg:_textField.text];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
	
	//내용을 지운다..
	[textField setText:@""];
	return YES;
}

- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
	[_textField becomeFirstResponder];
}

- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
	[_textField resignFirstResponder];
}

-(void)receiveMsg:(NSNotification *)notification{
	ClubChatData *data=(ClubChatData *)notification.object;
	if([data.header isEqualToString:@"/대화"]){
		
		///대화|특정인의 대화명|하고싶은메세지| ::
		NSString *who=[data.array objectAtIndex:0];
		NSString *msg=[data.array objectAtIndex:1];
		
		NSString *viewMsg=[NSString stringWithFormat:@"%@님의 말>> %@",who,msg];
		
		_textView.text=[_textView.text stringByAppendingString:viewMsg];
		_textView.text=[_textView.text stringByAppendingString:@"\n"];
	
	}else if([data.header isEqualToString:@"/공지"]){
		//공지|서버에서 알려주는 메세지| ::
		NSString *msg=[data.array objectAtIndex:0];
		
		_textView.text=[_textView.text stringByAppendingString:@"\n"];
		_textView.text=[_textView.text stringByAppendingString:msg];
		_textView.text=[_textView.text stringByAppendingString:@"\n\n"];
	}else if([data.header isEqualToString:@"/귓속말"]){
		
		NSString *who=[data.array objectAtIndex:0];
		NSString *msg=[data.array objectAtIndex:1];
		
		NSString *viewMsg=[NSString stringWithFormat:@"%@님의 귓속말>> %@",who,msg];
		
		_textView.text=[_textView.text stringByAppendingString:viewMsg];
		_textView.text=[_textView.text stringByAppendingString:@"\n"];
	}
	
	NSLog(@"가로 : %f, 세로 : %f",_textView.contentSize.width,_textView.contentSize.height);
	
	[_textView scrollRangeToVisible:NSMakeRange([_textView.text length]-7,7)];
}
/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	
	[_textView release];
	[_textField release];
	
    [super dealloc];
}


@end
