//
//  ClubChatReceiveMemoTableCellViewController.m
//  ClubChat
//
//  Created by 이규주 on 09. 07. 12.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "ClubChatReceiveMemoTableCellViewController.h"
#import "ClubChatData.h"

@implementation ClubChatReceiveMemoTableCellViewController
/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/
/*
 - (void)viewWillAppear:(BOOL)animated {
 [super viewWillAppear:animated];
 }
 */
/*
 - (void)viewDidAppear:(BOOL)animated {
 [super viewDidAppear:animated];
 }
 */
/*
 - (void)viewWillDisappear:(BOOL)animated {
 [super viewWillDisappear:animated];
 }
 */
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
	
	[textField resignFirstResponder];
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}
//X버튼 클릭시 쪽지를 없앤다..
-(IBAction) touchXButton:(id)sender{
	//쪽지가 보내진 쪽지화면을 화면에서 제거한다..
	//제거될쪽지의 위치가 들어간다..
	[[NSNotificationCenter defaultCenter] postNotificationName:@"SelectDeleteMemoNotification" object:[NSString stringWithFormat:@"%d",_number]];
}

//쪽지내용등을 설정한다...
-(void) receiveNumber:(int)number sender:(NSString *)sender memo:(NSString *)receiveMessage{

	_number=number;

	if(_sender){
		[_sender release];
	}
	
	_sender=[sender copy];
	[senderInfo setText:[NSString stringWithFormat:@"%@님이 보낸 쪽지",_sender]];
	[receiveMemo setText:receiveMessage];
}

//쪽지보내기..
///쪽지|받을사람대화명|보낼메세지| ::
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
	
	NSString *tmpData=[textField.text stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
	
	if(![tmpData isEqualToString:@""]){
		NSMutableArray *array=[[NSMutableArray alloc] init];
		[array addObject:_sender];
		[array addObject:tmpData];
		
		ClubChatData *data=[[ClubChatData alloc] initWithHeader:@"/쪽지" andWithArray:array];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"sendMsg" object:data];
		
		[array release];
	}
	
	//보낸쪽지내용을 초기화시킨다..
	[textField setText:@""];
	[textField resignFirstResponder];
	
	//쪽지가 보내진 쪽지화면을 화면에서 제거한다..
	//제거될쪽지의 위치가 들어간다..
	[[NSNotificationCenter defaultCenter] postNotificationName:@"SelectDeleteMemoNotification" object:[NSString stringWithFormat:@"%d",_number]];
	
	return YES;
}

- (void)dealloc {
	[textField		release];
	[senderInfo		release];
	[receiveMemo	release];
	[_sender		release];
    [super			dealloc];
}


@end
